from toee import *
from utilities import *

def san_dialog( attachee, triggerer ):
	if (attachee.leader_get() == OBJ_HANDLE_NULL):
		if (game.global_flags[45] == 1):
			triggerer.begin_dialog( attachee, 100 )
		else:
			triggerer.begin_dialog( attachee, 1 )
	elif (game.global_flags[45] == 1):
		triggerer.begin_dialog( attachee, 250 )
	else:
		triggerer.begin_dialog( attachee, 200 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[44] = 1
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		game.global_vars[29] = game.global_vars[29] + 1
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	game.global_flags[44] = 0
	return RUN_DEFAULT

def san_join( attachee, triggerer ):
	obj = find_npc_near( attachee, 8004)
	if (obj != OBJ_HANDLE_NULL and game.global_flags[806] == 0):
		triggerer.follower_add(obj)
	return RUN_DEFAULT

def san_disband( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8004 and game.global_flags[806] == 0):
			triggerer.follower_remove(obj)
	return RUN_DEFAULT

def equip_transfer( attachee, triggerer ):
	itemA = attachee.item_find(4205)
	if (itemA != OBJ_HANDLE_NULL):
		itemA.destroy()
		create_item_in_inventory( 4205, triggerer )
	itemB = attachee.item_find(6026)
	if (itemB != OBJ_HANDLE_NULL):
		itemB.destroy()
		create_item_in_inventory( 6026, triggerer )
	itemC = attachee.item_find(6233)
	if (itemC != OBJ_HANDLE_NULL):
		itemC.destroy()
		create_item_in_inventory( 6233, triggerer )
	itemD = attachee.item_find(6120)
	if (itemD != OBJ_HANDLE_NULL):
		itemD.destroy()
		create_item_in_inventory( 6120, triggerer )
	itemE = attachee.item_find(6059)
	if (itemE != OBJ_HANDLE_NULL):
		itemE.destroy()
		create_item_in_inventory( 6059, triggerer )
	itemF = attachee.item_find(6045)
	if (itemF != OBJ_HANDLE_NULL):
		itemF.destroy()
		create_item_in_inventory( 6045, triggerer )
	itemG = attachee.item_find(4060)
	if (itemG != OBJ_HANDLE_NULL):
		itemG.destroy()
		create_item_in_inventory( 4060, triggerer )
	create_item_in_inventory( 7002, attachee )
	create_item_in_inventory( 7002, attachee )
	create_item_in_inventory( 7002, attachee )
	create_item_in_inventory( 7002, attachee )
	create_item_in_inventory( 7002, attachee )
	create_item_in_inventory( 7002, attachee )
	return RUN_DEFAULT