from toee import *

def san_dialog( attachee, triggerer ):
	attachee.turn_towards(triggerer)
	if (attachee.has_met(triggerer)):
		if (attachee.leader_get() == OBJ_HANDLE_NULL):
			triggerer.begin_dialog( attachee, 90 )
		triggerer.begin_dialog( attachee, 200 )
	else:
		triggerer.begin_dialog( attachee, 1 )
	return SKIP_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (not game.combat_is_active()):
		for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
			if (is_safe_to_talk(attachee,obj)):
				if (not attachee.has_met(obj)):
					obj.begin_dialog(attachee,1)
					game.new_sid = 0
	return RUN_DEFAULT

def san_dying( attachee, triggerer ):
	if (attachee.leader_get() == OBJ_HANDLE_NULL):
		game.global_vars[23] = game.global_vars[23] + 1
		if (game.global_vars[23] >= 2):
			game.party[0].reputation_add( 1 )
	else:
		game.global_vars[29] = game.global_vars[29] + 1
	return RUN_DEFAULT

def make_otis_talk( attachee, triggerer, line):
	npc = find_npc_near(attachee,8014)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,320)
	return SKIP_DEFAULT

def switch_to_thrommel( attachee, triggerer):
	npc = find_npc_near(attachee,8031)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,40)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,570)
	return SKIP_DEFAULT

def elmo_joins_first_time( attachee, triggerer):
	triggerer.money_adj(-20000)
	create_item_in_inventory( 6049, attachee )
	create_item_in_inventory( 6051, attachee )
	create_item_in_inventory( 4098, attachee )
#	game.fade(600,0,0,1)
	attachee.item_wield_best_all()
	return SKIP_DEFAULT

def equip_transfer( attachee, triggerer ):
	itemA = attachee.item_find(6011)
	if (itemA != OBJ_HANDLE_NULL):
		itemA.destroy()
		create_item_in_inventory( 6011, triggerer )
	itemB = attachee.item_find(6016)
	if (itemB != OBJ_HANDLE_NULL):
		itemB.destroy()
		create_item_in_inventory( 6016, triggerer )
	create_item_in_inventory( 7001, attachee )
	return RUN_DEFAULT

