from toee import *
from utilities import *

def san_dialog( attachee, triggerer ):
	attachee.turn_towards(triggerer)
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 170 )
	elif (not attachee.has_met(triggerer)):
		triggerer.begin_dialog( attachee, 1 )
	else:
		triggerer.begin_dialog( attachee, 20 )
	return SKIP_DEFAULT

def san_first_heartbeat( attachee, triggerer ):
	if (game.global_flags[203] == 1):
		attachee.object_flag_unset(OF_OFF)
	return RUN_DEFAULT

def disappear( attachee ):
	attachee.object_flag_set(OF_OFF)
	return RUN_DEFAULT

def get_rep( attachee, triggerer ):
	if triggerer.reputation_has( 7 ) == 0:
		triggerer.reputation_add( 7 )
	game.global_vars[25] = game.global_vars[25] + 1
	if ( game.global_vars[25] >= 3 and triggerer.reputation_has( 8 ) == 0):
		triggerer.reputation_add( 8 )
	return RUN_DEFAULT

def san_disband( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8056 and game.global_flags[806] == 0):
			triggerer.follower_remove(obj)
			triggerer.begin_dialog(attachee,1000)
	return RUN_DEFAULT

def together_again( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8056 and game.global_flags[806] == 0):
			triggerer.begin_dialog(attachee,1010)
	return RUN_DEFAULT

def buttin2( attachee, triggerer, line):
	npc = find_npc_near(attachee,8056)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	return SKIP_DEFAULT

