from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	if (game.global_flags[88] == 1):
		triggerer.begin_dialog( attachee, 1 )
	elif (game.quests[37].state == qs_completed):
		triggerer.begin_dialog( attachee, 20 )
	elif (attachee.has_met( triggerer )):
		triggerer.begin_dialog( attachee, 60 )
	else:
		triggerer.begin_dialog( attachee, 110 )
	return SKIP_DEFAULT


def san_heartbeat( attachee, triggerer ):
	if (game.quests[37].state == qs_completed):
		game.new_sid = 0
	elif (game.global_flags[89] == 0):
		if (not game.combat_is_active()):
			for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
				if (attachee.can_see(obj)):
					game.global_flags[89] = 1
					game.timevent_add( reset_global_flag_89, ( attachee, ), 7200000 ) # call reset_global_flag_89 in 2 hours
					attachee.steal_from(obj)
					return RUN_DEFAULT
	return RUN_DEFAULT

def san_caught_thief( attachee, triggerer ):
	triggerer.begin_dialog( attachee, 120 )
	return RUN_DEFAULT

def reset_global_flag_89( attachee ):
	game.global_flags[89] = 0
	return RUN_DEFAULT

def make_dick_talk( attachee, triggerer, line):
	npc = find_npc_near(attachee,8018)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,130)
	return SKIP_DEFAULT
