from toee import *

def san_dialog( attachee, triggerer ):
	if (game.global_flags[105] == 1):
		attachee.attack(triggerer)
	elif (find_npc_near(attachee,8027) == OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 1 )
	elif (game.quests[46].state == qs_unknown):
		triggerer.begin_dialog( attachee, 20 )
	else:
		triggerer.begin_dialog( attachee, 40 )
	return SKIP_DEFAULT

def san_first_heartbeat( attachee, triggerer ):
	if (attachee.leader_get() == OBJ_HANDLE_NULL and not game.combat_is_active()):
		game.global_vars[715] = 0
	return RUN_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (game.global_vars[715] == 0 and attachee.leader_get() == OBJ_HANDLE_NULL and not game.combat_is_active()):
		attachee.cast_spell(spell_fog_cloud, attachee)
		attachee.spells_pending_to_memorized()
	game.global_vars[715] = game.global_vars[715] + 1

def san_dying( attachee, triggerer ):
	game.global_flags[132] = 1
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	game.global_flags[132] = 0
	return RUN_DEFAULT

def san_will_kos( attachee, triggerer ):
	if (game.global_flags[105] == 0):
		return SKIP_DEFAULT
	else:
		return RUN_DEFAULT

def switch_dialog( attachee, triggerer, line):
	npc = find_npc_near(attachee,8027)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,1)
	return SKIP_DEFAULT
