from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	attachee.turn_towards(triggerer)
	if (game.global_flags[140] == 1):
		if (game.global_vars[15] <= 4):
			triggerer.begin_dialog( attachee, 1 )
		else:
			triggerer.begin_dialog( attachee, 10 )
	elif (not attachee.has_met(triggerer)):
		triggerer.begin_dialog( attachee, 20 )
	elif (game.quests[52].state >= qs_accepted):
		triggerer.begin_dialog( attachee, 40 )
	else:
		triggerer.begin_dialog( attachee, 30 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[116] = 1
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	game.global_flags[116] = 0
	return RUN_DEFAULT

def san_first_heartbeat( attachee, triggerer ):
	if (game.global_flags[310] == 1):
		attachee.object_flag_set(OF_OFF)
		game.global_flags[116] = 1
	return RUN_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (attachee.map == 5067 and game.global_flags[872] == 0):
		chest = game.obj_create( 1012, location_from_axis (409L, 498L))
		chest.rotation = 4
		create_item_in_inventory( 6315, chest )
		create_item_in_inventory( 6197, chest )
		create_item_in_inventory( 6186, chest )
		create_item_in_inventory( 12037, chest )
		game.global_flags[872] = 1
	return RUN_DEFAULT

def kill_antonio( attachee ):
	game.timevent_add( antonio_dead, ( attachee, ), 86400000 )
	return RUN_DEFAULT

def antonio_dead( attachee ):
	game.global_flags[311] = 1
	return RUN_DEFAULT

def kill_alrrem( attachee ):
	game.timevent_add( alrrem_dead, ( attachee, ), 86400000 )
	return RUN_DEFAULT

def alrrem_dead( attachee ):
	game.global_flags[312] = 1
	return RUN_DEFAULT
