from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	if (not attachee.has_met(triggerer)):
		triggerer.begin_dialog( attachee, 1 )
	elif (game.global_flags[144] == 1):
		triggerer.begin_dialog( attachee, 90 )
	else:
		triggerer.begin_dialog( attachee, 80 )
	return SKIP_DEFAULT

def san_start_combat( attachee, triggerer ):
	leader = game.leader
	if (not attachee.has_met(leader)):
		game.counters[0] = game.counters[0] + 1
		if ((game.counters[0] >= 4) and (group_percent_hp(leader) > 30) and (game.global_flags[852] == 0)):
			for pc in game.party:
				if pc.type == obj_t_pc:
					attachee.ai_shitlist_remove( pc )
			game.global_flags[852] = 1
			leader.begin_dialog( attachee, 1 )
##			game.new_sid = 0	## removed by Livonya
			return SKIP_DEFAULT

	## THIS IS USED FOR BREAK FREE
	for obj in game.party[0].group_list():
		if (obj.distance_to(attachee) <= 3 and obj.stat_level_get(stat_hp_current) >= -9):
			return RUN_DEFAULT		
	while(attachee.item_find(8903) != OBJ_HANDLE_NULL):
		attachee.item_find(8903).destroy()
	if (attachee.d20_query(Q_Is_BreakFree_Possible)):
		create_item_in_inventory( 8903, attachee )
##		attachee.d20_send_signal(S_BreakFree)

	return RUN_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[338] = 1
	return RUN_DEFAULT

def san_will_kos( attachee, triggerer ):
	if (triggerer.type == obj_t_pc):
		if ((not attachee.has_met(triggerer)) or (group_percent_hp(triggerer) <= 30)):
			return RUN_DEFAULT
	return SKIP_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (not game.combat_is_active()):
		if (game.global_flags[144] == 1):
			for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
				if (attachee.has_met(obj)):
					if (is_safe_to_talk(attachee,obj)):
						obj.begin_dialog(attachee,90)
						game.new_sid = 0
	return RUN_DEFAULT

def smigmal_escape( attachee, triggerer ):
	attachee.runoff(attachee.location-3)
	game.timevent_add( smigmal_return, ( attachee, ), 7200000 )
	return RUN_DEFAULT

def smigmal_return( attachee ):
	attachee.object_flag_unset(OF_OFF)
	game.global_flags[144] = 1
	return RUN_DEFAULT
