from toee import *

def san_dialog( attachee, triggerer ):
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 110 )
	elif (game.global_flags[148] == 0):
		if (game.global_flags[325] == 1):
			triggerer.begin_dialog( attachee, 230 )
		else:
			triggerer.begin_dialog( attachee, 1 )
	elif (game.global_flags[38] == 1):
		triggerer.begin_dialog( attachee, 170 )
	else:
		triggerer.begin_dialog( attachee, 160 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[153] = 1
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		game.global_vars[29] = game.global_vars[29] + 1
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	game.global_flags[153] = 0
	return RUN_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (not game.combat_is_active()):
		if (game.quests[20].state == qs_completed):
			for pc in game.party:
				if pc.has_follower(8001):
					pc.follower_remove( attachee )
					game.new_sid = 0
	return RUN_DEFAULT

def san_first_heartbeat( attachee, triggerer ):
	if (game.global_flags[149] == 1):
		attachee.object_flag_unset(OF_OFF)
	return RUN_DEFAULT

def	san_spell_cast( attachee, triggerer, spell ):
	if ( spell.spell == spell_dispel_magic or spell.spell == spell_break_enchantment or spell.spell == spell_dispel_evil ):
		game.global_flags[148] = 1
		triggerer.begin_dialog( attachee, 70 )
	return RUN_DEFAULT

def run_off( attachee, triggerer ):
	attachee.standpoint_set( STANDPOINT_NIGHT, 257 )
	attachee.standpoint_set( STANDPOINT_DAY, 257 )
	attachee.runoff(attachee.location-3)
	return RUN_DEFAULT

def LookHedrack( attachee, triggerer, line):
	npc = find_npc_near(attachee,8032)
	if (npc != OBJ_HANDLE_NULL) and ( game.global_flags[146] == 0 ):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,10)
	return SKIP_DEFAULT

def get_rep( attachee, triggerer ):
	if triggerer.reputation_has( 7 ) == 0:
		triggerer.reputation_add( 7 )
	game.global_vars[25] = game.global_vars[25] + 1
	if ( game.global_vars[25] >= 3 and triggerer.reputation_has( 8 ) == 0):
		triggerer.reputation_add( 8 )
	return RUN_DEFAULT