from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 80 )
	return SKIP_DEFAULT

def san_resurrect( attachee, triggerer ):
	if (attachee.leader_get() == OBJ_HANDLE_NULL):
		game.timevent_add( ask_to_rejoin, (attachee, triggerer) , 1 )
	return RUN_DEFAULT


def ask_to_rejoin( attachee, triggerer ):
	if (attachee.leader_get() == OBJ_HANDLE_NULL):
		for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
			if (is_safe_to_talk(attachee,obj)):
				obj.begin_dialog( attachee, 50 )
				return SKIP_DEFAULT
		game.timevent_add( ask_to_rejoin, (attachee, triggerer) , 1000 )
	return SKIP_DEFAULT


def run_off( attachee, triggerer ):
	attachee.runoff(attachee.location-3)
	return SKIP_DEFAULT
