from toee import *

def san_dialog( attachee, triggerer ):
	if ( not attachee.has_met(triggerer) ):
		if game.quests[35].state == qs_completed:
			triggerer.begin_dialog(attachee,300)
		else:
			triggerer.begin_dialog(attachee,1)
	elif ( game.quests[60].state == qs_botched ):
		triggerer.begin_dialog(attachee,260)
	elif ( game.quests[60].state == qs_completed and game.global_flags[315] == 1 ):
		triggerer.begin_dialog(attachee,400)
	elif ( game.global_flags[317] == 1 ):
		triggerer.begin_dialog(attachee,330)
	elif ( game.quests[60].state <= qs_mentioned ):
		triggerer.begin_dialog(attachee,470)
	else:
		triggerer.begin_dialog(attachee,200)
	return SKIP_DEFAULT

def san_heartbeat( attachee, triggerer ):
	icon = game.obj_create( 2011, location_from_axis (556L, 524L) )
	door = game.obj_create( 150, location_from_axis (556L, 524L) )
#	door.rotation = 2
	door.rotation = 0
	game.new_sid = 0
	return RUN_DEFAULT

def san_dying( attachee, triggerer ):
	game.quests[60].state = qs_botched
	return RUN_DEFAULT

def buttin( attachee, triggerer, line):
	npc = find_npc_near(attachee,8015)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,150)
	return SKIP_DEFAULT
