from toee import *
from utilities import *

def san_dialog( attachee, triggerer ):
	if (attachee.leader_get() != OBJ_HANDLE_NULL):
		triggerer.begin_dialog( attachee, 100 )
	else:
		triggerer.begin_dialog( attachee, 1 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.quests[59].state = qs_botched
	return RUN_DEFAULT

def buttin( attachee, triggerer, line):
	npc = find_npc_near(attachee,8058)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	else:
		triggerer.begin_dialog(attachee,240)
	return SKIP_DEFAULT

def san_disband( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8058 and game.global_flags[806] == 0):
			triggerer.follower_remove(obj)
			triggerer.begin_dialog(attachee,1000)
	return RUN_DEFAULT

def together_again( attachee, triggerer ):
	for obj in triggerer.group_list():
		if (obj.name == 8058 and game.global_flags[806] == 0):
			triggerer.begin_dialog(attachee,1010)
	return RUN_DEFAULT

def buttin2( attachee, triggerer, line):
	npc = find_npc_near(attachee,8058)
	if (npc != OBJ_HANDLE_NULL):
		triggerer.begin_dialog(npc,line)
		npc.turn_towards(attachee)
		attachee.turn_towards(npc)
	return SKIP_DEFAULT

def equip_transfer( attachee, triggerer ):
	itemA = attachee.item_find(4042)
	if (itemA != OBJ_HANDLE_NULL):
		itemA.destroy()
		create_item_in_inventory( 4042, triggerer )
	itemB = attachee.item_find(6044)
	if (itemB != OBJ_HANDLE_NULL):
		itemB.destroy()
		create_item_in_inventory( 6044, triggerer )
	create_item_in_inventory( 7001, attachee )
	create_item_in_inventory( 7001, attachee )
	create_item_in_inventory( 7001, attachee )
	create_item_in_inventory( 7001, attachee )
	return RUN_DEFAULT