from toee import *

def OnBeginSpellCast( spell ):
	print "Animal Trance OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-enchantment-conjure", spell.caster )

	# HTN - sort the list by distance from caster
	spell.spell_target_list_sort( SORT_TARGET_LIST_BY_DIST_FROM_CASTER, SORT_TARGET_LIST_ORDER_ASCENDING )
	print "target_list sorted by dist from [", spell.caster, "] (closest to farthest): ", spell.target_list

def	OnSpellEffect( spell ):
	print "Animal Trance OnSpellEffect"

	dice = dice_new( '2d6' )
	hd_remaining = dice.roll()

	remove_list = []

	spell.duration = 0

	spell.caster_partsys_id = game.particles( 'sp-Animal Trance', spell.caster )

	for target_item in spell.target_list:
		obj_hit_dice = target_item.obj.hit_dice_num

		if (target_item.obj.is_category_type( mc_type_animal ) == 1) and (target_item.obj.stat_level_get( stat_intelligence ) < 3) and (obj_hit_dice <= hd_remaining):

			hd_remaining = hd_remaining - obj_hit_dice

			if target_item.obj.saving_throw_spell( spell.dc, D20_Save_Will, D20STD_F_NONE, spell.caster, spell.id ):
				# saving throw successful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30001 )

				game.particles( 'Fizzle', target_item.obj )
				remove_list.append( target_item.obj )

			else:
				# saving throw unsuccessful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30002 )

				target_item.obj.condition_add_with_args( 'sp-Animal Trance', spell.id, spell.duration, 0 )

		else:
			game.particles( 'Fizzle', target_item.obj )
			remove_list.append( target_item.obj )

	spell.target_list.remove_list( remove_list )
	spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Animal Trance OnBeginRound"

def OnEndSpellCast( spell ):
	print "Animal Trance OnEndSpellCast"