from toee import *

def OnBeginSpellCast( spell ):
	print "Burning Hands OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-evocation-conjure", spell.caster )

def	OnSpellEffect( spell ):
	print "Burning Hands OnSpellEffect"

	remove_list = []

	dam = dice_new( '1d4' )
	dam.number = min( 5, spell.caster_level )

	game.particles( 'sp-Burning Hands', spell.caster )

	npc = spell.caster

	#### Caster is NOT in game party
	if npc.type != obj_t_pc and npc.leader_get() == OBJ_HANDLE_NULL:
		range = 15
		target_list = list(game.obj_list_cone( spell.caster, OLC_CRITTERS, range, -30, 150 ))
		target_list.remove(spell.caster)
		for obj in target_list:
			if obj.reflex_save_and_damage( spell.caster, spell.dc, D20_Save_Reduction_Half, D20STD_F_NONE, dam, D20DT_FIRE, D20DAP_UNSPECIFIED, D20A_CAST_SPELL, spell.id ):
				# saving throw successful
				obj.float_mesfile_line( 'mes\\spell.mes', 30001 )
			else:
				# saving throw unsuccessful
				obj.float_mesfile_line( 'mes\\spell.mes', 30002 )


	#### Caster is in game party
	if npc.type == obj_t_pc or npc.leader_get() != OBJ_HANDLE_NULL:
		
		# get all targets in a 10ft cone (180')
		for target_item in spell.target_list:

			remove_list.append( target_item.obj )

			if target_item.obj.reflex_save_and_damage( spell.caster, spell.dc, D20_Save_Reduction_Half, D20STD_F_NONE, dam, D20DT_FIRE, D20DAP_UNSPECIFIED, D20A_CAST_SPELL, spell.id ):
				# saving throw successful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30001 )
			else:
				# saving throw unsuccessful
				target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30002 )

	spell.target_list.remove_list( remove_list )
	spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Burning Hands OnBeginRound"

def OnEndSpellCast( spell ):
	print "Burning Hands OnEndSpellCast"