from toee import *

def OnBeginSpellCast( spell ):
	print "Dimension Door OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-transmutation-conjure", spell.caster )

def	OnSpellEffect( spell ):
	print "Dimension Door OnSpellEffect"

	game.particles( 'sp-Dimension Door', spell.caster )

	target = spell.caster

	if target.d20_query_has_spell_condition( sp_Dimensional_Anchor ) == 0:
		target.fade_to( 0, 10, 40 )
		# WIP! SMM: added timeevent to trigger fadein (in realtime)
		game.particles( 'sp-Dimension Door', target )
		game.timeevent_add( fade_back_in, ( target, spell.target_loc, spell ), 750, 1 )
	else:
		target.float_mesfile_line( 'mes\\spell.mes', 30011 )
		game.particles( 'Fizzle', target )
		spell.target_list.remove_target( target )
		spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Dimension Door OnBeginRound"

def OnEndSpellCast( spell ):
	print "Dimension Door OnEndSpellCast"

def fade_back_in( target, loc, spell ):
	target.move( loc, 0.0, 0.0 )
	game.particles( 'sp-Dimension Door', target )
	target.fade_to( 255, 10, 5 )
	spell.target_list.remove_target( target )
	spell.spell_end( spell.id )
