from toee import *

def OnBeginSpellCast( spell ):
	print "Flame Strike OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-evocation-conjure", spell.caster )

def	OnSpellEffect( spell ):
	print "Flame Strike OnSpellEffect"

	remove_list = []

	# damage is split between FIRE and DIVINE damage
	dam = dice_new( '1d6' )
	dam.number = min( 15, spell.caster_level )
	dam_over2 = dice_new( "0d0" )
	dam_over2.bonus = dam.roll() / 2

	game.particles( 'sp-Flame Strike', spell.target_loc )

	# get all targets in a 10ft radius
	for target_item in spell.target_list:

		# do reflex saving throw on FIRE damage, then do damage/save check for DIVINE damage
		if target_item.obj.reflex_save_and_damage( spell.caster, spell.dc, D20_Save_Reduction_Half, D20STD_F_NONE, dam_over2, D20DT_FIRE, D20DAP_UNSPECIFIED, D20A_CAST_SPELL, spell.id ):

			target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30001 )

			# saving throw successful, apply half damage
			target_item.obj.spell_damage_with_reduction( spell.caster, D20DT_UNSPECIFIED, dam_over2, D20DAP_UNSPECIFIED, DAMAGE_REDUCTION_HALF, D20A_CAST_SPELL, spell.id )

		else:

			target_item.obj.float_mesfile_line( 'mes\\spell.mes', 30002 )

			# saving throw unsuccessful, apply full damage
			target_item.obj.spell_damage( spell.caster, D20DT_UNSPECIFIED, dam_over2, D20DAP_UNSPECIFIED, D20A_CAST_SPELL, spell.id )

		remove_list.append( target_item.obj )

	spell.target_list.remove_list( remove_list )
	spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Flame Strike OnBeginRound"

def OnEndSpellCast( spell ):
	print "Flame Strike OnEndSpellCast"