from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	triggerer.begin_dialog( attachee, 1 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[369] = 1
	if game.quests[42].state >= qs_mentioned:
		game.quests[42].state = qs_completed
		triggerer.reputation_add( 21 )
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	if game.quests[42].state == qs_completed:
		game.quests[42].state = qs_botched
		triggerer.reputation_remove( 21 )
	return RUN_DEFAULT

def kill_lodriss( attachee ):
	attachee.object_flag_set(OF_OFF)
	return RUN_DEFAULT

def kill_skole( attachee ):
	game.timevent_add( skole_dead, ( attachee, ), 86400000 )
	return RUN_DEFAULT

def skole_dead( attachee ):
	game.global_flags[201] = 1
	return RUN_DEFAULT

def get_rep( attachee, triggerer ):
	if triggerer.reputation_has( 7 ) == 0:
		triggerer.reputation_add( 7 )
	game.global_vars[25] = game.global_vars[25] + 1
	if ( game.global_vars[25] >= 3 and triggerer.reputation_has( 8 ) == 0):
		triggerer.reputation_add( 8 )
	return RUN_DEFAULT

def make_like( attachee, triggerer ):
	if ( attachee.reaction_get( triggerer ) <= 71 ):
		attachee.reaction_set( triggerer, 71 )
	return SKIP_DEFAULT
