from utilities import *

from toee import *

def san_dialog( attachee, triggerer ):
	attachee.turn_towards(triggerer)
	if (game.global_flags[139] == 1):
		triggerer.begin_dialog( attachee, 1 )
	elif (not attachee.has_met(triggerer)):
		triggerer.begin_dialog( attachee, 10 )
	elif (game.quests[52].state == qs_unknown):
		triggerer.begin_dialog( attachee, 20 )
	else:
		triggerer.begin_dialog( attachee, 40 )
	return SKIP_DEFAULT

def san_dying( attachee, triggerer ):
	game.global_flags[115] = 1
	return RUN_DEFAULT

def san_resurrect( attachee, triggerer ):
	game.global_flags[115] = 0
	return RUN_DEFAULT

def san_first_heartbeat( attachee, triggerer ):
	if (game.global_flags[311] == 1):
		attachee.object_flag_set(OF_OFF)
		game.global_flags[115] = 1
	return RUN_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (attachee.map == 5067 and game.global_flags[872] == 0):
		chest = game.obj_create( 1012, location_from_axis (409L, 498L))
		chest.rotation = 4
		create_item_in_inventory( 6313, chest )
		create_item_in_inventory( 6197, chest )
		create_item_in_inventory( 6186, chest )
		create_item_in_inventory( 12037, chest )
		game.global_flags[872] = 1
	return RUN_DEFAULT

def kill_tubal( attachee ):
	game.timevent_add( tubal_dead, ( attachee, ), 172800000 )
	return RUN_DEFAULT

def tubal_dead( attachee ):
	game.global_flags[310] = 1
	return RUN_DEFAULT