from toee import *

def san_dialog( attachee, triggerer ):
	triggerer.begin_dialog( attachee, 1 )
	return SKIP_DEFAULT


def san_heartbeat( attachee, triggerer ):
	game.global_flags[328] = 1
	if (not game.combat_is_active()):
		for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
			if (is_safe_to_talk(attachee,obj)):
				game.new_sid = 0
				obj.begin_dialog(attachee,1)
				return RUN_DEFAULT
	return RUN_DEFAULT


def switch_to_iuz( cuthbert, pc, line ):
	iuz = find_npc_near(cuthbert,8042)
	if (iuz != OBJ_HANDLE_NULL):
		pc.begin_dialog(iuz,line)
		iuz.turn_towards(cuthbert)
		cuthbert.turn_towards(iuz)
	else:
		turn_off_gods( cuthbert, pc )
	return SKIP_DEFAULT


def cuthbert_raise_good( cuthbert, pc ):
	# raise all PC's and PC followers
	for obj in game.party:
		if (obj.stat_level_get(stat_hp_current) <= -10):
			obj.resurrect( CRITTER_R_CUTHBERT_RESURRECT, 0 )
		else:
#			obj.obj_set_int( obj_f_hp_damage, 0 )
			dice = dice_new("1d10+1000")
			obj.heal( OBJ_HANDLE_NULL, dice )
			obj.healsubdual( OBJ_HANDLE_NULL, dice )
	return SKIP_DEFAULT


def turn_off_gods( cuthbert, pc ):
	cuthbert.remove_from_initiative()
	cuthbert.object_flag_set(OF_OFF)
	iuz = find_npc_near(cuthbert,8042)
	if (iuz != OBJ_HANDLE_NULL):
		iuz.remove_from_initiative()
		iuz.object_flag_set(OF_OFF)
	return SKIP_DEFAULT
