from toee import *

def san_dialog( attachee, triggerer ):
	if ( pc.item_find(3014) != OBJ_HANDLE_NULL ):
		triggerer.begin_dialog(attachee,50)
	else:
		triggerer.begin_dialog(attachee,1)
	return SKIP_DEFAULT

def san_heartbeat( attachee, triggerer ):
	if (not game.combat_is_active()):
		good_pc = OBJ_HANDLE_NULL
		near_pc = OBJ_HANDLE_NULL
		for obj in game.obj_list_vicinity(attachee.location,OLC_PC):
			if (is_safe_to_talk(attachee,obj)):
				near_pc = obj
				if ((obj.stat_level_get(stat_alignment) == LAWFUL_GOOD) or (obj.stat_level_get(stat_alignment) == NEUTRAL_GOOD) or (obj.stat_level_get(stat_alignment) == CHAOTIC_GOOD)):
					good_pc = obj
				if (obj.item_find(3014) != OBJ_HANDLE_NULL ):
					obj.begin_dialog(attachee,50)
					game.new_sid = 0
					return RUN_DEFAULT
		if (good_pc != OBJ_HANDLE_NULL):
			good_pc.begin_dialog(attachee,1)
			game.new_sid = 0
		if (near_pc != OBJ_HANDLE_NULL):
			near_pc.begin_dialog(attachee,1)
			game.new_sid = 0
	return RUN_DEFAULT

def distribute_magic_items(npc,pc):
	for obj in pc.group_list():
		obj.money_adj(2000000)
		create_item_in_inventory( 8007, obj )
		create_item_in_inventory( 6082, obj )
	return RUN_DEFAULT

def transfer_scrolls(npc,pc):
	# give out 12 first level wizard scrolls to pc
	create_item_in_inventory( 9288, pc )
	create_item_in_inventory( 9280, pc )
	create_item_in_inventory( 9438, pc )
	create_item_in_inventory( 9431, pc )
	create_item_in_inventory( 9383, pc )
	create_item_in_inventory( 9509, pc )
	create_item_in_inventory( 9467, pc )
	create_item_in_inventory( 9333, pc )
	create_item_in_inventory( 9238, pc )
	create_item_in_inventory( 9229, pc )
	create_item_in_inventory( 9159, pc )
	create_item_in_inventory( 9056, pc )
	return RUN_DEFAULT	

def knight_party(npc,pc):
	pc.reputation_add( 22 )
	for obj in pc.group_list():
		create_item_in_inventory( 6128, obj )
		create_item_in_inventory( 6129, obj )
	return RUN_DEFAULT

def run_off(npc, pc):
	for obj in game.obj_list_vicinity(npc.location,OLC_NPC):
		if (obj.leader_get() == OBJ_HANDLE_NULL):
			obj.runoff(obj.location-3)
	return
